<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用户电话" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入用户电话"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="标题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入标题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="类型" prop="billType">
        <el-select v-model="queryParams.billType" placeholder="请选择类型" clearable size="small">
          <el-option
            v-for="dict in billTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
       <el-form-item label="创建时间" prop="createTime">
                 <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
              </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['his:userBill:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="userbillList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="账单ID" align="center" prop="billId" />
      <el-table-column label="用户昵称" align="center" prop="name" />
      <el-table-column label="用户电话" align="center" prop="phone" />
      <el-table-column label="标题" align="center" prop="title" />
      <el-table-column label="金额" align="center" prop="money" />
      <el-table-column label="余额" align="center" prop="balance" />
      <el-table-column label="类型" align="center" prop="billType">
        <template slot-scope="scope">
          <dict-tag :options="billTypeOptions" :value="scope.row.billType"/>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180"/>

      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right">

 <template slot-scope="scope">

        <el-button
            size="mini"
            type="text"
            @click="handledetails(scope.row)"
          >详情
        </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

 <el-drawer
        :with-header="false"
        size="75%"
         :title="show.title" :visible.sync="show.open">
     <userBillDetails  ref="Details" />
   </el-drawer>

  </div>
</template>

<script>
import { listUserbill, getUserbill, delUserbill, addUserbill, updateUserbill, exportUserbill } from "@/api/his/userBill";
import userBillDetails from '../../../components/his/userBillDetails.vue';
export default {
  name: "Userbill",
  components: { userBillDetails },
    data() {
      return {
        show:{
                title:"账单详情",
                open:false,
              },
        // 遮罩层
        loading: true,
        // 导出遮罩层
        exportLoading: false,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 医生账单记录表格数据
        userbillList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 类型字典
        billTypeOptions: [],
        createTime:null,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          userId: null,
          title: null,
          billType: null,
          createTime: null,
          businessId: null,
          sTime:null,
          eTime:null,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        }
      };
    },
    created() {
      this.getList();
      this.getDicts("sys_bill_type").then(response => {
        this.billTypeOptions = response.data;
      });
    },
    methods: {
      handledetails(row){
              this.show.open=true;
              setTimeout(() => {
                    this.$refs.Details.getDetails(row.billId,row.name);
              }, 1);
          },
      change(){
            if(this.createTime!=null){
              this.queryParams.sTime=this.createTime[0];
              this.queryParams.eTime=this.createTime[1];
            }else{
              this.queryParams.sTime=null;
              this.queryParams.eTime=null;
            }
      
          },
      /** 查询医生账单记录列表 */
      getList() {
        this.loading = true;
        listUserbill(this.queryParams).then(response => {
          this.userbillList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          billId: null,
          userId: null,
          title: null,
          money: null,
          balance: null,
          billType: null,
          remark: null,
          createTime: null,
          businessId: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
         this.createTime=null;
        this.queryParams.sTime=null;
        this.queryParams.eTime=null;
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.billId)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加医生账单记录";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const billId = row.billId || this.ids
        getUserbill(billId).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改医生账单记录";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.billId != null) {
              updateUserbill(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addUserbill(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const billIds = row.billId || this.ids;
        this.$confirm('是否确认删除医生账单记录编号为"' + billIds + '"的数据项?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return delUserbill(billIds);
          }).then(() => {
            this.getList();
            this.msgSuccess("删除成功");
          }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$confirm('是否确认导出所有医生账单记录数据项?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(() => {
            this.exportLoading = true;
            return exportUserbill(queryParams);
          }).then(response => {
            this.download(response.msg);
            this.exportLoading = false;
          }).catch(() => {});
      }
    }
  };
  </script>
